#!/usr/bin/env bun
import fs from "node:fs";

const supportedTags = [
  "a",
  "abbr",
  "article",
  "blockquote",
  "button",
  "cite",
  "code",
  "details",
  "div",
  "figure",
  "footer",
  "h1",
  "h2",
  "h3",
  "h4",
  "hr",
  "iframe",
  "img",
  "input",
  "ins",
  "label",
  "li",
  "main",
  "nav",
  "ol",
  "output",
  "p",
  "pre",
  "rt",
  "ruby",
  "section",
  "select",
  "span",
  "strong",
  "sub",
  "summary",
  "sup",
  "table",
  "tbody",
  "td",
  "thead",
  "tr",
  "ul",
  "var",
  "video",
].sort();

function replaceFile(file: string, search: string | RegExp, replace: string) {
  const content = fs.readFileSync(file, "utf-8");
  fs.writeFileSync(file, content.replace(search, replace));
}

replaceFile(
  "src/macro.d.ts",
  /export type SupportedTag =(\n\s+\| "\w+")+;/,
  `export type SupportedTag =\n  | "${supportedTags.join('"\n  | "')}";`
);

replaceFile(
  "src/babel/macro.ts",
  /const supportedTags = new Set<SupportedTag>\(\[(\n\s+"\w+",)+\n]\);/,
  `const supportedTags = new Set<SupportedTag>([\n  "${supportedTags.join('",\n  "')}",\n]);`
);
